/***************************************************************************
                          net2.h  -  description
                             -------------------
    begin                : Thu Feb 19 2004
    copyright            : (C) 2004 by Gene Ruebsamen
    email                : gene@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NET2_H
#define NET2_H

#include <vector>
#include <iostream>
#include <cmath>
#include <cassert>
#include "brain.h"
#include "../utils.h"

using std::vector;
using namespace std;

template <class T>
class Net2 : public Brain<T>
{
public:
	Net2(int, int, int, int);								// input, hidden, output, recurrent layers
	Net2(const Net2<T> &);
	~Net2();
	void putWeights(vector<T> &);							// initialize the weights
	const Net2 &operator=(const Net2 &);			// overloaded assignment operator
 	vector<T> activate(vector<T> &);			// pass in input, and get output
  unsigned int getGeneSize() const;					// get Total size of ANN (weights)
	vector<T> getWeights() const;
	const	int getInputSize() const			// get Input size of ANN (weights)
		{ return input_size; }
	const	int getHiddenSize() const			// get Hidden size of ANN (weights)
		{ return hidden_size; }
	const	int getRecurrentSize() const	// get Recurrent size of ANN (weights)
		{ return recurrent_size; }
	const	int getOutputSize() const			// get Output size of ANN (weights)
		{ return output_size; }
private:
	T *whi;
	T *whb;
	T **whr;
	T *ho;
	T *woi;
	T *wob;
	T *oo;
	T **hiddencopy;
	int time;
	int input_size;
	int hidden_size;
	int output_size;
	int recurrent_size;
};

#endif
