/***************************************************************************
                          neuron.cpp  -  description
                             -------------------
    begin                : Tue Feb 10 2004
    copyright            : (C) 2004 by Gene Ruebsamen
    email                : gene@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "neuron.h"

template class Neuron<float>;
template class Neuron<double>;
template class NeuronLayer<float>;
template class NeuronLayer<double>;
template class MemoryLayer<float>;
template class MemoryLayer<double>;



template <class T>
Neuron<T>::Neuron(int numInputs) : m_NumInputs(numInputs+1)
{
	for (int i=0;i<m_NumInputs;++i)
	{
		m_vecWeights.push_back(RandClamped<T>());
	}
}

template <class T>
bool Neuron<T>::operator==(const Neuron<T> &right) const
{
	if (m_NumInputs != right.m_NumInputs)
		return false;
	if (m_vecWeights != right.m_vecWeights)
		return false;

	return true;
}



template <class T>
NeuronLayer<T>::NeuronLayer(int numNeurons, int numInputsPerNeuron) :
m_NumNeurons(numNeurons)
{
	for (int i=0;i<m_NumNeurons;++i)
	{
		m_vecNeurons.push_back(Neuron<T>(numInputsPerNeuron));
	}
}

template <class T>
bool NeuronLayer<T>::operator==(const NeuronLayer<T> &right) const
{
	if (m_NumNeurons != right.m_NumNeurons)
		return false;
	if (m_vecNeurons != right.m_vecNeurons)
		return false;

	return true;
}


template <class T>
MemoryLayer<T>::MemoryLayer(int numNeurons) :
m_NumNeurons(numNeurons)
{
	m_vecNeurons.reserve(m_NumNeurons);
}

template <class T>
bool MemoryLayer<T>::operator==(const MemoryLayer<T> &right) const
{
	if (m_NumNeurons != right.m_NumNeurons)
		return false;
	if (m_vecNeurons != right.m_vecNeurons)
		return false;

	return true;
}

