/***************************************************************************
                          neuron.h  -  description
                             -------------------
    begin                : Tue Feb 10 2004
    copyright            : (C) 2004 by Gene Ruebsamen
    email                : gene@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NEURON_H
#define NEURON_H

#include <vector>
#include "../utils.h"

using std::vector;

template <class T>
class Neuron
{
public:
	Neuron(int numInputs);
	bool operator==(const Neuron<T> &) const;
	bool operator!=(const Neuron<T> &right) const
		{ return !(*this == right); }

	vector<T> m_vecWeights;
	int m_NumInputs;
};

template <class T>
class NeuronLayer
{
public:
	NeuronLayer(int numNeurons, int numInputsPerNeuron);
	bool operator==(const NeuronLayer<T> &) const;
	bool operator!=(const NeuronLayer<T> &right) const
		{ return !(*this == right); }

	int m_NumNeurons;
	vector<Neuron<T> > m_vecNeurons;
};

template <class T>
class MemoryLayer
{
public:
	MemoryLayer(int numNeurons);
	bool operator==(const MemoryLayer<T> &) const;
	bool operator!=(const MemoryLayer<T> &right) const
		{ return !(*this == right); }

	int m_NumNeurons;
	vector<T> m_vecNeurons;
};

#endif
