/***************************************************************************
                          constants.h  -  description
                             -------------------
    begin                : Sat Nov 24 2001
    copyright            : (C) 2001 by Gene Ruebsamen
    email                : gene@erachampion.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef CONSTANTS_H
#define CONSTANTS_H

#include <ode/ode.h>

// Genetic Algorithm Constants
const int POPSIZE = 80;
const double CROSSOVER=0.80;
const double MUTATION=0.006;
const int TIMEOUT = 750;
// old code below
const int GENERATIONS = 10000;

// global ODE constants
const int SIMSTEPMS = 50;		// 50ms simulation steps
const int ODE_MAX_CONTACTS = 10;
const double STARTZ=0.2;   //.2 for runner
const double SPACING=3.0;
const double GRAVITY=0.5;
const dReal ERP = 0.2;
const dReal CFM = 0.00005;//1e-5;
// old code below:
const double SIMSTEP=0.05;     //0.05 good for hexapod, 0.015 for box
const long MAXTIME=750;
const int NUMHUMANS=80;

// ann
const double BIAS = 1.0;
const double ACTRESPONSE = -1.0;
// old code below:
const int ANNSTEP=5;

#endif
