/***************************************************************************
                          genetic.h  -  description
                             -------------------
    begin                : Fri Feb 13 2004
    copyright            : (C) 2004 by Gene Ruebsamen
    email                : gene@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GENETIC_H
#define GENETIC_H

#include <iostream>
#include <cassert>
#include "organisms/organism.h"
#include "constants.h"

//template <class T>
namespace std
{
  struct greater< Organism<float> * >
  {
    bool operator()( Organism<float> * lhs, Organism<float> * rhs) const
    {
			return lhs->getFitness() > rhs->getFitness();
    }
  };
}

using std::cout;
using std::endl;

class Genetic
{
public:
	Genetic();
	~Genetic();
	vector<Organism<float> *> epoch(vector<Organism<float> *> &);
	void printStats() const;
	void setNumElite(unsigned int=1);
private:
	Organism<float> *roulette_selection(const vector<Organism<float> *> &);
	unsigned m_Generation;
	unsigned m_NumElite;
	double m_AvgFitness;
	double m_TotalFitness;
	double m_MaxFitness;
};

#endif
