/***************************************************************************
                          hopper.h  -  description
                             -------------------
    begin                : Sun Feb 24 2002
    copyright            : (C) 2002 by Gene Ruebsamen
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef HOPPER_H
#define HOPPER_H
#include <ode/ode.h>
#include <drawstuff/drawstuff.h>
#include "creature.h"

class Hopper : public Creature {
public:
	Hopper(dWorldID,dSpaceID,dReal,dReal,dReal);		// constructor (world,space,x,y,z,in,hid,out,recur)
	~Hopper();	// destructor
	void draw(bool=false) const;
	void getInputs(float *) const;
	const dReal * getHeadPos(void) const;
	void shutoff(void);
	void setMuscles(const float *);
	void footContact(dGeomID,dGeomID,dGeomID);   		// are the feet touching the ground
	void bodyContact(dGeomID,dGeomID,dGeomID);   		// are thebody touching the ground
	float getFitness(void) const;
	void randomForce(void) const;
	void randomTorque(void) const;
	bool hasFallen(void) const;
  void printStats(void) const;
  void clearSensor(void);
  void Reset(double,double,double);
private:
	void constructBody(dWorldID,dSpaceID,dReal,dReal,dReal);
  float fitcount;
	const int numBody;
	const int numGeom;
	const int numJoint;
	int clock;
	bool r_foot_sens;
  bool l_foot_sens;
	bool fallen;
	dBodyID *body;
	dGeomID *geom;
	dJointID *joint;
	dJointGroupID jGroup;
	dGeomID geomGroup;
	//  declarations
	dReal TORSO[3]; 	// length, width height
	dReal LEG1[3];	
	dReal LEG2[3];	
	dReal GAP;
};

#endif

