/***************************************************************************
                          net.h  -  description
                             -------------------
    begin                : Sat Dec 1 2001
    copyright            : (C) 2001 by Gene Ruebsamen
    email                : gene@erachampion.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NET_H
#define NET_H

#include <iostream>

using namespace std;

class Net {
public:
	Net(int, int, int, int);								// input, hidden, output, recurrent layers
	Net(const Net &);
	~Net();
	void initWeights(float *);							// initialize the weights
	const Net &operator=(const Net &);			// overloaded assignment operator
 	const float * const getOutput(const float * const);			// pass in input, and get output
	const	int getSize(void) const;					// get Total size of ANN (weights)
	const	int getInputSize(void) const			// get Input size of ANN (weights)
		{ return input_size; }
	const	int getHiddenSize(void) const			// get Hidden size of ANN (weights)
		{ return hidden_size; }
	const	int getRecurrentSize(void) const	// get Recurrent size of ANN (weights)
		{ return recurrent_size; }
	const	int getOutputSize(void) const			// get Output size of ANN (weights)
		{ return output_size; }
private:
	float *whi;
	float *whb;
	float **whr;
	float *ho;
	float *woi;
	float *wob;
	float *oo;
	float **hiddencopy;
	int time;
	int input_size;
	int hidden_size;
	int output_size;
	int recurrent_size;
};

#endif
