/***************************************************************************
                          world.h  -  description
                             -------------------
    begin                : Mon Feb 9 2004
    copyright            : (C) 2004 by Gene Ruebsamen
    email                : gene@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef WORLD_H
#define WORLD_H

#include <ode/ode.h>
#include "utils.h"
#include "constants.h"

class World
{
public:
  World(dVector3 gravity);
  virtual ~World();
  dWorldID getWorldID();
  dSpaceID getSpaceID();
	// Step the world
	virtual bool fStep (unsigned int uMilliseconds);
	virtual bool fStepFast (unsigned int uMilliseconds, unsigned int iterations);

	// This wrapper is called by the physics library to get information
	// about object collisions
	static void CollisionCallback (void *pData, dGeomID o1, dGeomID o2);
  
private:
	// This actually implements the collision callback
	void CollisionCallback (dGeomID o1, dGeomID o2);

  dWorldID m_WorldID;
  dJointGroupID m_CollisionJointGroup;
  dSpaceID m_SpaceID;
};

#endif
